DECLARE SUB GetName (NAMERCD%, NAME$)
PRINT "    ͻ "
PRINT "                            DESCEND                         "
PRINT "                 Decendant Chart Generator                  "
PRINT "              (C) Copyright 1989 by Kent Riggins            "
PRINT "    ͼ "


INPUT "     Enter path for input: ", fp$
INPUT "     Enter path and file for output: ", outfile$
'== Our Program Variables ===============================================
DIM STACK%(1000), GenStack%(1000)
fp$ = "C:\PAFDATA\"

Main:
GOSUB OpenAllFiles
GOSUB DescendentSearch
GOSUB PrintFromWho

CLOSE ALL
END

OpenAllFiles: '==========================================================
OPEN outfile$ FOR OUTPUT AS #8

OPEN fp$ + "NAMADD2.DAT" FOR RANDOM AS #1 LEN = 224
   FIELD 1, 41 AS AName$, 41 AS AAdd1$, 41 AS AAdd2$, 41 AS AAdd3$, 26 AS ATel$, 26 AS AStake$, 8 AS AStakenum$
GET #1, (2)
pname$ = LEFT$(AName$, (INSTR(AName$, CHR$(0)) - 1))
padd1$ = LEFT$(AAdd1$, (INSTR(AAdd1$, CHR$(0)) - 1))
padd2$ = LEFT$(AAdd2$, (INSTR(AAdd2$, CHR$(0)) - 1))
padd3$ = LEFT$(AAdd3$, (INSTR(AAdd3$, CHR$(0)) - 1))
ptel$ = LEFT$(ATel$, (INSTR(ATel$, CHR$(0)) - 1))
pstake$ = LEFT$(AStake$, (INSTR(AStake$, CHR$(0)) - 1))
pstakenum$ = LEFT$(AStakenum$, (INSTR(AStakenum$, CHR$(0)) - 1))
CLOSE #1

OPEN fp$ + "NAME2.DAT" FOR RANDOM AS #1 LEN = 21
   FIELD 1, 2 AS NLLINK$, 17 AS NNAME$, 2 AS NRLINK$

   FIELD 1, 11 AS NAMEMAX$, 10 AS NFIRSTDELET$

OPEN fp$ + "indiv2.dat" FOR RANDOM AS #2 LEN = 92
   FIELD 2, 2 AS ISURNAME$, 2 AS IGIVEN1$, 2 AS IGIVEN2$, 2 AS IGIVEN3$, 2 AS ITITLE$, 1 AS ISEX$, 4 AS IBIRTHDT$, 2 AS IBPL1$, 2 AS IBPL2$, 2 AS IBPL3$, 2 AS IBPL4$, 4 AS ICHRISTDT$, 2 AS ICPL1$, 2 AS ICPL2$, 2 AS ICPL3$, 2 AS ICPL4$, 4 AS  _
IDEATHDT$, 2 AS IDPL1$, 2 AS IDPL2$, 2 AS IDPL3$, 2 AS IDPL4$, 4 AS IBURIALDT$, 2 AS IBUPL1$, 2 AS IBUPL2$, 2 AS IBUPL3$, 2 AS IBUPL4$, 3 AS IBAPTDT$, 2 AS IBAPTEMP$, 3 AS IEDOWDT$, 2 AS IEDTEMP$, 3 AS ICHILDtoPARENTSealDT$, 2 AS ICTPSTEMP$, 2 AS  _
IOlderSiblPtr$, 2 AS IndOwnMarrPtr$, 2 AS IParentMarrPtr$, 10 AS IIDNUM$, 2 AS INotePadPtr$


	FIELD 2, 11 AS INDIVIDMAX$, 10 AS IFIRSTDELET$, 71 AS XXXX$
GET #2, 1
INDIVIDMAX% = VAL(INDIVIDMAX$)

OPEN fp$ + "MARR2.DAT" FOR RANDOM AS #3 LEN = 28
	FIELD 3, 2 AS MHusPtr$, 2 AS MWifPtr$, 2 AS MChildPtr$, 4 AS MarrDT$, 2 AS MPL1$, 2 AS MPL2$, 2 AS MPL3$, 2 AS MPL4$, 3 AS MWifToHusSealDT$, 2 AS MWifToHusSealTemp$, 2 AS MHusOtherMarrPtr$, 2 AS MWifOtherMarrPtr$


	FIELD 3, 11 AS MarrMAX$, 10 AS MarrFIRSTDELET$, 7 AS XXXX$

GET #3, 1
MarrMAX% = VAL(MarrMAX$)
RETURN
PrintFromWho: '====================================================
PRINT #8,
PRINT #8,
PRINT #8, pname$
PRINT #8, padd1$
PRINT #8, padd2$
PRINT #8, padd3$
PRINT #8, ptel$
PRINT #8, pstake$
PRINT #8, pstakenum$

RETURN

DescendentSearch:
PTR = 0
PRINT "Enter starting RIN: ";
INPUT STRIN%

GEN% = 1
PTR = PTR + 1: STACK%(PTR) = STRIN%: GenStack%(PTR) = GEN%
Start:
   IF PTR = 0 THEN GOTO FINISH
   RIN% = STACK%(PTR)
   GET #2, (RIN% + 1): GEN% = GenStack%(PTR): PTR = PTR - 1
   GEN$ = STR$(GEN%) + "-"
   GOSUB PrintIndividual

   IF CVI(IndOwnMarrPtr$) = 0 THEN GOTO Start
   GET #3, (CVI(IndOwnMarrPtr$) + 1)
   IF ISEX$ = "M" THEN
	  RIN% = CVI(MWifPtr$)
	  GET #2, (RIN% + 1)
   ELSE
	  RIN% = CVI(MHusPtr$)
	  GET #2, (RIN% + 1)
   END IF
   GEN$ = " S-"
   GOSUB PrintIndividual

   IF CVI(MChildPtr$) = 0 THEN GOTO Start
   PTR = PTR + 1: STACK%(PTR) = CVI(MChildPtr$): GenStack%(PTR) = GEN% + 1
StoreChildren:
   GET #2, (STACK%(PTR) + 1)
   IF CVI(IOlderSiblPtr$) = 0 THEN
	  GOTO Start
   ELSE
	  PTR = PTR + 1: STACK%(PTR) = CVI(IOlderSiblPtr$): GenStack%(PTR) = GEN% + 1
	  GOTO StoreChildren
   END IF


FINISH:
   RETURN

PrintIndividual:
CALL GetName(CVI(ISURNAME$), SURname$)
CALL GetName(CVI(IGIVEN1$), name1$)
CALL GetName(CVI(IGIVEN2$), name2$)
CALL GetName(CVI(IGIVEN3$), name3$)
CALL GetName(CVI(ITITLE$), TITLE$)
PRINT #8, SPACE$(GEN% * 2); GEN$; TITLE$; name1$; name2$; name3$; SURname$;
PRINT #8, "(" + RIGHT$(STR$(RIN%), LEN(STR$(RIN%)) - 1) + ")"

RETURN



SUB ConvertDate (a$, YEAR%, MONTH%, DAY%, MODIFIER%, DYEAR%) STATIC'===============

	a1 = ASC(LEFT$(a$, 1))
	a2 = ASC(MID$(a$, 2, 1))
	a3 = ASC(MID$(a$, 3, 1))
	a4 = ASC(MID$(a$, 4, 1))

	YEAR% = a1 * 16 + INT(a2 / 16)
	MONTH% = (a2 - INT(a2 / 16) * 16) * 2 + INT(a3 / 128)
	DAY% = INT((a3 - INT(a3 / 128) * 128) / 4)
	MODIFIER% = a3 - INT(a3 / 4) * 4
	IF a4 = 0 THEN
	   DYEAR% = 0
	ELSE
	   DYEAR% = YEAR% + a4
	END IF
END SUB

SUB GetName (NAMERCD%, NAME$) STATIC'==========================================
   SHARED NNAME$
   IF NAMERCD% > 0 THEN
	  GET #1, (NAMERCD% + 1)
	  NAME$ = NNAME$
	  lg% = INSTR(NAME$, CHR$(0)) - 1
	  NAME$ = LEFT$(NAME$, lg%)
	  NAME$ = NAME$ + " "
   ELSE
	  NAME$ = ""
   END IF
END SUB

